<?php
require 'vendor/tp-token-retriever/php/src/TerapeakTokenRetriever.php';

if (empty($_GET['secret_key'])) {
  die("Error: No secret API key supplied.");
}
$secret_key = $_GET['secret_key'];

try {
  $ttr = new TerapeakTokenRetriever($secret_key);
  $ttr->makeCall();
  // this token is for your use!
  $token = $ttr->getToken();
} catch(TerapeakTokenRetrieverException $e) {
  // Add in your own error handling, the Token Retrieval failed
  die('Error: ' . $e->getMessage() . ' (Error #: ' . $e->getCode() . ')');
}
?>
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    <style type="text/css">
    body { margin: 0; font-family: sans-serif; }
    .widget-config {
      text-align: center;
      margin-bottom: 50px;
      padding: 75px;
      border-bottom: 1px solid #aaa;
      -moz-box-shadow: 3px 3px 5px 6px #ddd;
      -webkit-box-shadow: 3px 3px 5px 6px #ddd;
      box-shadow: 3px 3px 5px 6px #ddd;
    }
    .widget-container {
      width: 80%;
      margin-left: auto;
      margin-right: auto;
    }
    .widget-container h4 { margin: 50px 0px; border-bottom: 1px solid #ccc; }
    .widget-config label { width: 90px; display: inline-block; text-align: right; }
    blockquote { color: #bbb; font-size: .7em; }
    #tpw-group-container-id { min-height: 300px; }
    </style>
    <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7/jquery.min.js"></script>
    
    <script type="text/javascript" src="tpw/tpw-init.js"></script>
    <script type="text/javascript">
    _TPW.init();
    _TPW.load('SalesMetrics', {container: 'containerSalesMetrics', apiToken: '<?php echo $token; ?>'});
    _TPW.load('SellerSales', {container: 'containerSellerSales', apiToken: '<?php echo $token; ?>'});
    
    _TPW.createGroup('SalesGroup', {container: 'tpw-group-container-id'});
    _TPW.load('SalesMetrics', {groupId: 'SalesGroup', apiToken: '<?php echo $token; ?>'});
    $(function () {
      $('#widget-config-form').submit(function () {
        $.each(_TPW.widgets, function (i, e) {
          e.config.sellerId = $('#seller-id').val();
          e.config.apiKey = $('#api-key').val();
          e.init(e.TPW, e.config);
        });
        $('.widget-container:hidden').fadeIn();
        return false;
      });
    });
    </script>
    </head>

    <body>
      <div class="widget-config">
      <h4>Global Settings</h4>
      <form id="widget-config-form" onsubmit="return false;">
        <p><label for="seller-id">Seller ID:</label> <input type="text" name="seller-id" id="seller-id"></p>
        <p><label for="api-key">API Key:</label> <input type="text" name="api-key" id="api-key"></p>
        <input type="submit">
      </form>
      <blockquote>Please note: other than the settings in the above form, each widget functions completely independently.</blockquote>
      </div>
      <div class="widget-container" style="display: none;">
        <h4>Sales Metrics Widget</h4>
        <div id="containerSalesMetrics">
        </div>
        <h4>Seller Sales Widget</h4>
        <div id="containerSellerSales"></div>
        
        <h4>Grouped Widgets</h4>
        <div id="tpw-group-container-id"></div>
      </div>
    </body>
</html>